// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// AddedReaction represents TL type `addedReaction#bc9c9b4f`.
type AddedReaction struct {
	// Type of the reaction
	Type ReactionTypeClass
	// Identifier of the chat member, applied the reaction
	SenderID MessageSenderClass
}

// AddedReactionTypeID is TL type id of AddedReaction.
const AddedReactionTypeID = 0xbc9c9b4f

// Ensuring interfaces in compile-time for AddedReaction.
var (
	_ bin.Encoder     = &AddedReaction{}
	_ bin.Decoder     = &AddedReaction{}
	_ bin.BareEncoder = &AddedReaction{}
	_ bin.BareDecoder = &AddedReaction{}
)

func (a *AddedReaction) Zero() bool {
	if a == nil {
		return true
	}
	if !(a.Type == nil) {
		return false
	}
	if !(a.SenderID == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (a *AddedReaction) String() string {
	if a == nil {
		return "AddedReaction(nil)"
	}
	type Alias AddedReaction
	return fmt.Sprintf("AddedReaction%+v", Alias(*a))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*AddedReaction) TypeID() uint32 {
	return AddedReactionTypeID
}

// TypeName returns name of type in TL schema.
func (*AddedReaction) TypeName() string {
	return "addedReaction"
}

// TypeInfo returns info about TL type.
func (a *AddedReaction) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "addedReaction",
		ID:   AddedReactionTypeID,
	}
	if a == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Type",
			SchemaName: "type",
		},
		{
			Name:       "SenderID",
			SchemaName: "sender_id",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (a *AddedReaction) Encode(b *bin.Buffer) error {
	if a == nil {
		return fmt.Errorf("can't encode addedReaction#bc9c9b4f as nil")
	}
	b.PutID(AddedReactionTypeID)
	return a.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (a *AddedReaction) EncodeBare(b *bin.Buffer) error {
	if a == nil {
		return fmt.Errorf("can't encode addedReaction#bc9c9b4f as nil")
	}
	if a.Type == nil {
		return fmt.Errorf("unable to encode addedReaction#bc9c9b4f: field type is nil")
	}
	if err := a.Type.Encode(b); err != nil {
		return fmt.Errorf("unable to encode addedReaction#bc9c9b4f: field type: %w", err)
	}
	if a.SenderID == nil {
		return fmt.Errorf("unable to encode addedReaction#bc9c9b4f: field sender_id is nil")
	}
	if err := a.SenderID.Encode(b); err != nil {
		return fmt.Errorf("unable to encode addedReaction#bc9c9b4f: field sender_id: %w", err)
	}
	return nil
}

// Decode implements bin.Decoder.
func (a *AddedReaction) Decode(b *bin.Buffer) error {
	if a == nil {
		return fmt.Errorf("can't decode addedReaction#bc9c9b4f to nil")
	}
	if err := b.ConsumeID(AddedReactionTypeID); err != nil {
		return fmt.Errorf("unable to decode addedReaction#bc9c9b4f: %w", err)
	}
	return a.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (a *AddedReaction) DecodeBare(b *bin.Buffer) error {
	if a == nil {
		return fmt.Errorf("can't decode addedReaction#bc9c9b4f to nil")
	}
	{
		value, err := DecodeReactionType(b)
		if err != nil {
			return fmt.Errorf("unable to decode addedReaction#bc9c9b4f: field type: %w", err)
		}
		a.Type = value
	}
	{
		value, err := DecodeMessageSender(b)
		if err != nil {
			return fmt.Errorf("unable to decode addedReaction#bc9c9b4f: field sender_id: %w", err)
		}
		a.SenderID = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (a *AddedReaction) EncodeTDLibJSON(b tdjson.Encoder) error {
	if a == nil {
		return fmt.Errorf("can't encode addedReaction#bc9c9b4f as nil")
	}
	b.ObjStart()
	b.PutID("addedReaction")
	b.Comma()
	b.FieldStart("type")
	if a.Type == nil {
		return fmt.Errorf("unable to encode addedReaction#bc9c9b4f: field type is nil")
	}
	if err := a.Type.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode addedReaction#bc9c9b4f: field type: %w", err)
	}
	b.Comma()
	b.FieldStart("sender_id")
	if a.SenderID == nil {
		return fmt.Errorf("unable to encode addedReaction#bc9c9b4f: field sender_id is nil")
	}
	if err := a.SenderID.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode addedReaction#bc9c9b4f: field sender_id: %w", err)
	}
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (a *AddedReaction) DecodeTDLibJSON(b tdjson.Decoder) error {
	if a == nil {
		return fmt.Errorf("can't decode addedReaction#bc9c9b4f to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("addedReaction"); err != nil {
				return fmt.Errorf("unable to decode addedReaction#bc9c9b4f: %w", err)
			}
		case "type":
			value, err := DecodeTDLibJSONReactionType(b)
			if err != nil {
				return fmt.Errorf("unable to decode addedReaction#bc9c9b4f: field type: %w", err)
			}
			a.Type = value
		case "sender_id":
			value, err := DecodeTDLibJSONMessageSender(b)
			if err != nil {
				return fmt.Errorf("unable to decode addedReaction#bc9c9b4f: field sender_id: %w", err)
			}
			a.SenderID = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetType returns value of Type field.
func (a *AddedReaction) GetType() (value ReactionTypeClass) {
	if a == nil {
		return
	}
	return a.Type
}

// GetSenderID returns value of SenderID field.
func (a *AddedReaction) GetSenderID() (value MessageSenderClass) {
	if a == nil {
		return
	}
	return a.SenderID
}
