// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// TranslateTextRequest represents TL type `translateText#9f758a6d`.
type TranslateTextRequest struct {
	// Text to translate
	Text string
	// A two-letter ISO 639-1 language code of the language from which the message is
	// translated. If empty, the language will be detected automatically
	FromLanguageCode string
	// A two-letter ISO 639-1 language code of the language to which the message is
	// translated
	ToLanguageCode string
}

// TranslateTextRequestTypeID is TL type id of TranslateTextRequest.
const TranslateTextRequestTypeID = 0x9f758a6d

// Ensuring interfaces in compile-time for TranslateTextRequest.
var (
	_ bin.Encoder     = &TranslateTextRequest{}
	_ bin.Decoder     = &TranslateTextRequest{}
	_ bin.BareEncoder = &TranslateTextRequest{}
	_ bin.BareDecoder = &TranslateTextRequest{}
)

func (t *TranslateTextRequest) Zero() bool {
	if t == nil {
		return true
	}
	if !(t.Text == "") {
		return false
	}
	if !(t.FromLanguageCode == "") {
		return false
	}
	if !(t.ToLanguageCode == "") {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (t *TranslateTextRequest) String() string {
	if t == nil {
		return "TranslateTextRequest(nil)"
	}
	type Alias TranslateTextRequest
	return fmt.Sprintf("TranslateTextRequest%+v", Alias(*t))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*TranslateTextRequest) TypeID() uint32 {
	return TranslateTextRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*TranslateTextRequest) TypeName() string {
	return "translateText"
}

// TypeInfo returns info about TL type.
func (t *TranslateTextRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "translateText",
		ID:   TranslateTextRequestTypeID,
	}
	if t == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Text",
			SchemaName: "text",
		},
		{
			Name:       "FromLanguageCode",
			SchemaName: "from_language_code",
		},
		{
			Name:       "ToLanguageCode",
			SchemaName: "to_language_code",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (t *TranslateTextRequest) Encode(b *bin.Buffer) error {
	if t == nil {
		return fmt.Errorf("can't encode translateText#9f758a6d as nil")
	}
	b.PutID(TranslateTextRequestTypeID)
	return t.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (t *TranslateTextRequest) EncodeBare(b *bin.Buffer) error {
	if t == nil {
		return fmt.Errorf("can't encode translateText#9f758a6d as nil")
	}
	b.PutString(t.Text)
	b.PutString(t.FromLanguageCode)
	b.PutString(t.ToLanguageCode)
	return nil
}

// Decode implements bin.Decoder.
func (t *TranslateTextRequest) Decode(b *bin.Buffer) error {
	if t == nil {
		return fmt.Errorf("can't decode translateText#9f758a6d to nil")
	}
	if err := b.ConsumeID(TranslateTextRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode translateText#9f758a6d: %w", err)
	}
	return t.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (t *TranslateTextRequest) DecodeBare(b *bin.Buffer) error {
	if t == nil {
		return fmt.Errorf("can't decode translateText#9f758a6d to nil")
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode translateText#9f758a6d: field text: %w", err)
		}
		t.Text = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode translateText#9f758a6d: field from_language_code: %w", err)
		}
		t.FromLanguageCode = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode translateText#9f758a6d: field to_language_code: %w", err)
		}
		t.ToLanguageCode = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (t *TranslateTextRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if t == nil {
		return fmt.Errorf("can't encode translateText#9f758a6d as nil")
	}
	b.ObjStart()
	b.PutID("translateText")
	b.Comma()
	b.FieldStart("text")
	b.PutString(t.Text)
	b.Comma()
	b.FieldStart("from_language_code")
	b.PutString(t.FromLanguageCode)
	b.Comma()
	b.FieldStart("to_language_code")
	b.PutString(t.ToLanguageCode)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (t *TranslateTextRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if t == nil {
		return fmt.Errorf("can't decode translateText#9f758a6d to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("translateText"); err != nil {
				return fmt.Errorf("unable to decode translateText#9f758a6d: %w", err)
			}
		case "text":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode translateText#9f758a6d: field text: %w", err)
			}
			t.Text = value
		case "from_language_code":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode translateText#9f758a6d: field from_language_code: %w", err)
			}
			t.FromLanguageCode = value
		case "to_language_code":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode translateText#9f758a6d: field to_language_code: %w", err)
			}
			t.ToLanguageCode = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetText returns value of Text field.
func (t *TranslateTextRequest) GetText() (value string) {
	if t == nil {
		return
	}
	return t.Text
}

// GetFromLanguageCode returns value of FromLanguageCode field.
func (t *TranslateTextRequest) GetFromLanguageCode() (value string) {
	if t == nil {
		return
	}
	return t.FromLanguageCode
}

// GetToLanguageCode returns value of ToLanguageCode field.
func (t *TranslateTextRequest) GetToLanguageCode() (value string) {
	if t == nil {
		return
	}
	return t.ToLanguageCode
}

// TranslateText invokes method translateText#9f758a6d returning error if any.
func (c *Client) TranslateText(ctx context.Context, request *TranslateTextRequest) (*Text, error) {
	var result Text

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
